// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4222 $
#ifndef __DBBOOK_H__
#define __DBBOOK_H__

#include <atomic>
#include <condition_variable>
#include <map>
#include <thread>

#include "config.h"
#include "Book.h"
#include "db.h"
#include "IO.h"
#include "Scene.h"

class DBBook : public Book
{
protected:
#ifdef WITH_MYSQL_BOOKS
	MYSQL *handle;
#else
	void *handle;
#endif
	//
	const std::string db_table;

public:
	DBBook(IO *const io, const std::string & host, const std::string & db, const std::string & user, const std::string & password, const std::string & db_table);
	DBBook(IO *const io);
	virtual ~DBBook();

	virtual void operator()() = 0;
};

#endif
