// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4222 $
#pragma once

#include <atomic>
#include <condition_variable>
#include <map>
#include <thread>

#include "config.h"
#include "DBBook.h"
#include "db.h"
#include "IO.h"
#include "Scene.h"

class DBBookLearn : public DBBook
{
protected:
#ifdef WITH_MYSQL_BOOKS
	MYSQL *handle;
#else
	void *handle;
#endif
	//
	const std::string db_table;

public:
	DBBookLearn(IO *const io, const std::string & host, const std::string & db, const std::string & user, const std::string & password, const std::string & db_table);
	DBBookLearn(IO *const io);
	virtual ~DBBookLearn();

	virtual void operator()();

	void learn(const Board & b, const PlayerColor c, const Move & epMove, const Move & bestMove, const int depth, const winner_t win);
};
