// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4837 $
#include "IO.h"

extern char REV_IO_UCI[];

class IO_UCI : public IO
{
private:
	bool defaultPonder;
	std::string name_extra;
	uint64_t prevHashFull;

	void forkProcess(const std::string & what);

public:
	IO_UCI(const std::map<std::string, std::string> & parameters, Tpt *const tt, Ptt *const ptt);
	virtual ~IO_UCI();

	virtual void emitCmd(const std::string what, ...) const;
	virtual void emitDebug(const std::string what, ...) const;
	virtual void tellAll(const std::string what, ...) const;
	virtual void emitThinking(const int moveNr, const unsigned depth, const unsigned seldepth, const int score, const unsigned time, const unsigned long nodes, VectorType<PVnode_t> & pv, const bool revPv, const double ebf, const calc_stats_t *const cs, const Scene *const s, const PlayerColor c, const int alpha, const int beta);

	void loop();
};
