// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4641 $
#pragma once

#include <stdio.h>
#include <string>
#include <vector>

#include "ChessPieceType.h"
#include "MoveType.h"
#include "VectorType.h"

#define INVALID_MOVE 10

typedef struct __PRAGMA_PACKED__ {
	union _u_ {
		struct _m_ {
			uint8_t fx : 8, fy : 8;
			uint8_t tx : 4, ty : 4;
			MoveType mt : 4;
			ChessPieceType promoteTo : 3;
			bool isCatchMove : 1;
		} m;

		uint32_t mui;
	} u;

	int32_t score; // for sorting
} Move;

constexpr Move invalidMove = { { { INVALID_MOVE, 0, 0, 0, REGULAR, NONE, false } }, 0 };

class Board;
std::string moveToString(const Move & m, const bool dash = true, const Board *const b = NULL, const bool isCheck = false);
bool moveCompareTo(const Move & a, const Move & b);
void dumpMoveList(const VectorType<Move> *const moveList);
Move * moveOrNull(Move *const m);

bool isValidMove(const Move & m);
bool isValidMove(const VectorType<Move> *const restrict ml, const Move & m);

bool isMove(const Move & m, const char *const str);
