// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4222 $
#include "Tweaks.h"
#include <stdlib.h>

#include "config.h"
#include "Gen.h"
#include "Exception.h"
#include "MoveList.h"
#include "MoveSort.h"

size_t initialMoveListSize = 32;

void setMoveListInitialSize(const size_t initialSize)
{
	initialMoveListSize = initialSize;
}

ssize_t indexOf(const VectorType<Move> & pv, const Move & which)
{
	const size_t nIn = pv.size();

	for(size_t i=0; i<nIn; i++) {
		if (moveCompareTo(pv.at(i), which))
			return i;
	}

	return -1;
}

std::string toString(const VectorType<Move> & ml, const bool reverse)
{
	const size_t nIn = ml.size();

	std::string out;

	for(size_t i=0; i<nIn; i++)
	{
		std::string cur = moveToString(ml.at(i), false);

		if (out.empty())
			out = cur;
		else if (reverse)
			out = cur + " " + out;
		else
			out += " " + cur;
	}

	return out;
}
