// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4914 $
#ifndef __PV_H__
#define __PV_H__

#include <stdlib.h>
#include <string.h>
#include <utility>

#include "Exception.h"
#include "Move.h"
#include "MoveList.h"
#include "Tweaks.h"
#include "Tpt.h"
#include "VectorType.h"

typedef enum { MS_SEARCH=0, MS_QS=1, MS_TPT=2, MS_SYZYGY=3, MS_BOOK=4, MS_DUMMY=5, MS_ONE_MOVE_ONLY=6, MS_EMERGENCY=7, MS_ML_CONV=8, MS_THREAD=9 } move_source_t;

typedef struct {
	uint64_t hash;
	Move m;
	int eval;
	move_source_t src;
} PVnode_t;

void assign(VectorType<PVnode_t> *const pv, const VectorType<Move> & source, const bool reverse);
ssize_t indexOf(const VectorType<PVnode_t> & pv, const Move & which);
ssize_t indexOf(const VectorType<PVnode_t> & pv, const uint64_t hash);
std::string pvToString(const VectorType<PVnode_t> & pv, const bool reverse, const bool debug, const bool uciMode);
void push_back(VectorType<PVnode_t> *const pv, const uint64_t hash, const Move & m, const int score, const move_source_t src);
std::string recreatePvFromHash(Tpt *const tt, const Scene *const sIn, const PlayerColor cIn, Move m, const bool debug, const bool uciMode);

#endif
