// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4222 $
// http://stackoverflow.com/questions/4792449/c0x-has-no-semaphores-how-to-synchronize-threads
#include "Tweaks.h"
#include <condition_variable>
#include <mutex>

#include "config.h"
#include "Semaphore.h"

Semaphore::Semaphore(int count_) : count(count_)
{
}

void Semaphore::notify()
{
	std::lock_guard<std::mutex> lck(mtx);

	++count;

	cv.notify_one();
}

int Semaphore::wait()
{
	std::unique_lock<std::mutex> lck(mtx);

	while(count == 0)
		cv.wait(lck);

	count--;

	return count;
}

bool Semaphore::tryWait(int *const cntOut)
{
	std::lock_guard<std::mutex> lck(mtx);

	if (count)
	{
		--count;
		*cntOut = count;
		return true;
	}

	return false;
}

void Semaphore::forget(const int n)
{
	std::lock_guard<std::mutex> lck(mtx);

	count -= n;
}
