// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4222 $
#ifndef __SEMAPHORE_H__
#define __SEMAPHORE_H__

#include <mutex>
#include <condition_variable>

class Semaphore
{
private:
	std::mutex mtx;
	std::condition_variable cv;
	int count;

public:
	Semaphore(const int count_ = 0);

	void notify();
	int wait();
	bool tryWait(int *const cnt);
	void forget(const int n);
};

#endif
