#include <string>

class Tune
{
private:
	void defaultSettings();

public:
	Tune(const std::string & filename);
	Tune();
	~Tune();

	bool setParam(const std::string & key, const int val);

	int aspiration_window_size;
	int divSumPositionValue;
	int mulObjValue;
	int mulROF;
	int mulDoublePawn;
	int contemptEndgame, contemptMiddlegame;
	int minThinkTime;
	int checkExtension;
	int lmr1sub, lmr1mul, lmr1div;
	int lmr2sub, lmr2mul, lmr2div;
	int lmrStart, lmrNext, lmrMinDepth;
	int mobilityMul;
	int moreBishops, noPawns, tooMuchPawns, mulIsolatedPawns;
	int iidMinDepth, iidReduce;
	int pawnMobilMul, knightMobilMul, bishopMobilMul, rookMobilMul, queenMobilMul, kingMobilMul;
	int centerControl;
	int pawnShield;
	int kingSafety;
	int roer;
	int tempo;
};

extern Tune *tune;

void initTune(const std::string & filename);
void freeTune();
