// (C) Folkert van Heusden. AGPL v3.0.
// $Revision: 4840 $
#include "Tweaks.h"
#include "config.h"

#include "ALG_position.h"
#include "Brain.h"
#include "Board.h"
#include "IO_UCI.h"
#include "MoveSort.h"
#include "Tpt.h"
#include "Move.h"
#include "ChessPiece.h"

void emitConfig()
{
	log(ll_ok, "cfg:");

	#ifdef _DEBUG
	log(ll_ok, "    _DEBUG");
	#else
	log(ll_ok, " no _DEBUG");
	#endif

	#ifdef WSJS
	log(ll_ok, "    WSJS");
	#else
	log(ll_ok, " no WSJS");
	#endif

	#ifdef ALWAYS_PONDER
	log(ll_ok, "    ALWAYS_PONDER");
	#else
	log(ll_ok, " no ALWAYS_PONDER");
	#endif

	#ifdef TRACE_THREADS
	log(ll_ok, "    TRACE_THREADS");
	#else
	log(ll_ok, " no TRACE_THREADS");
	#endif

	#ifdef USE_TT
	log(ll_ok, "    USE_TT");
	#else
	log(ll_ok, " no USE_TT");
	#endif

	#ifdef BLIND
	log(ll_ok, "    BLIND");
	#else
	log(ll_ok, " no BLIND");
	#endif

	#ifdef WITH_CONTEMPT
	log(ll_ok, "    WITH_CONTEMPT");
	#else
	log(ll_ok, " no WITH_CONTEMPT");
	#endif

	#ifdef QUIESCENCE
	log(ll_ok, "    QUIESCENCE");
	#ifdef QS_TT_UPD
	log(ll_ok, "    QS TT UPDATE");
	#else
	log(ll_ok, " no QS TT UPDATE");
	#endif
	#else
	log(ll_ok, " no QUIESCENCE");
	#endif

	log(ll_ok, "    MAX_QUIESCENCE_DEPTH: %d", MAX_QUIESCENCE_DEPTH);

	#ifdef NULL_MOVE
	log(ll_ok, "    NULL_MOVE");
	#else
	log(ll_ok, " no NULL_MOVE");
	#endif

	log(ll_ok, "    NULL_MOVE_JUMP_MAX %d", NULL_MOVE_JUMP_MAX);

	log(ll_ok, "    TPT_IO_BUFFER_SIZE %d", TPT_IO_BUFFER_SIZE);
	log(ll_ok, "    TPT HASH-SIZE %u", sizeof(tptEntry));
	log(ll_ok, "    TPT HASH-GROUP-SIZE %u", sizeof(tptHashGroup));

	#ifdef VERY_BASIC_EVAL
	log(ll_ok, "    VERY_BASIC_EVAL");
	#else
	log(ll_ok, " no VERY_BASIC_EVAL");
	#endif

	#ifdef REQUIRE_ALL_POSSIBLE_MOVES
	log(ll_ok, "     REQUIRE_ALL_POSSIBLE_MOVES");
	#else
	log(ll_ok, " no  REQUIRE_ALL_POSSIBLE_MOVES");
	#endif

	log(ll_ok, "    ASPIRATION_WINDOW_SIZE %d", ASPIRATION_WINDOW_SIZE);

	log(ll_ok, "    POLLING_TIMEOUT %d", POLLING_TIMEOUT);

	log(ll_ok, "    BOOK_WDL_MIN_HITS %d", BOOK_WDL_MIN_HITS);

	#ifdef WITH_MYSQL_BOOKS
	log(ll_ok, "    WITH_MYSQL_BOOKS");
	#else
	log(ll_ok, " no WITH_MYSQL_BOOKS");
	#endif

	#ifdef W_SYZYGY
	log(ll_ok, "    W_SYZYGY");
	#else
	log(ll_ok, " no W_SYZYGY");
	#endif

	#ifdef W_SQLITE3
	log(ll_ok, "    W_SQLITE3");
	#else
	log(ll_ok, " no W_SQLITE3");
	#endif

	log(ll_ok, "    DEFAULT_HASHTABLE_SIZE %d", DEFAULT_HASHTABLE_SIZE);

	log(ll_ok, "    AVERAGE_MOVELIST_SIZE %d", AVERAGE_MOVELIST_SIZE);

	log(ll_ok, "    SE_MIN_PROBE_DEPTH %d", SE_MIN_PROBE_DEPTH);

	// FIXME dump Tune

	#ifdef USE_MMAP
	log(ll_ok, "    USE_MMAP");
	#else
	log(ll_ok, " no USE_MMAP");
	#endif

	log(ll_ok, "    IT_DEEPENING_MAX_REPEAT_MOVE_SEL %d", IT_DEEPENING_MAX_REPEAT_MOVE_SEL);

	log(ll_ok, "    MMAP_1GB_THRESHOLD %d", MMAP_1GB_THRESHOLD);

	#ifdef WITH_LMR
	log(ll_ok, "    WITH_LMR");
	log(ll_ok, "    LATE_MOVE_RED_AFTER_N_MOVES_1 %d", LATE_MOVE_RED_AFTER_N_MOVES_1);
	log(ll_ok, "    LATE_MOVE_RED_AFTER_N_MOVES_2 %d", LATE_MOVE_RED_AFTER_N_MOVES_2);
	#else
	log(ll_ok, " no WITH_LMR");
	#endif

	log(ll_ok, "    Move size: %ld", sizeof(Move));
	log(ll_ok, "    ChessPieceState size: %ld", sizeof(ChessPieceState));
	log(ll_ok, "    BoardState size: %ld", sizeof(BoardState));
	log(ll_ok, "    SceneState size: %ld", sizeof(SceneState));

	const char *revs[] = { REV_BOARD, REV_BRAIN, REV_IO_UCI, REV_MOVESORT, REV_SCENE, REV_TPT };
	for(unsigned int i=0; i<sizeof(revs) / sizeof(revs[0]); i++)
		log(ll_ok, "Rev %s", revs[i]);
}
